#! /usr/bin/python

# Post-install script

import sys
import os
import subprocess
import shutil
import aperiot
from aperiot.parsergen import *

def generate_parser():
    print "* Generating Aperio parser"
    parser = build_parser('metacfg_wat', verbose=True)
    print "* Aperio parser generated"
    print "* Saving Aperio parser"
    dir = aperiot.__path__[0]
    print "* Aperio found in '" + str(dir) + "'"
    sys.path.append(dir)
    save_parser(parser, dir, 'metacfg_wat', verbose=True)
    print "* Aperio parser saved in '" + dir + "'"
    bootstrap(dir)

def bootstrap(pkg_dir):
    print "* Bootstrapping"
    platform = sys.platform.lower()
    if platform.startswith('linux'):
        bin_dir = 'bin'
    elif platform.startswith('win'):
        bin_dir = 'Scripts'
    full_bin_dir = os.path.abspath(os.path.join(sys.prefix, bin_dir))
    aprcompiler = os.path.join(full_bin_dir, 'aprcompiler.py')
    aprsource = os.path.join(os.getcwd(), 'src', 'aperiot', 'metacfg_bootstrap.apr')
    shutil.copy(aprsource, pkg_dir)
    aprsource = os.path.join(pkg_dir, aprsource)
    current = os.getcwd()
    print "* Current directory is '" + str(current) + "'"
    os.chdir(pkg_dir)
    print "* Changed directory to '" + str(os.getcwd()) + "'"
    exit_code = subprocess.call(['python', aprcompiler, '-vtfd', pkg_dir, aprsource])
    print "* Bootstrap return code: " + str(exit_code)
    parser = build_parser('metacfg_bootstrap', verbose=True)
    print "* Aperio bootstraped parser generated"
    print "* Saving Aperio bootstrapped parser"
    save_parser(parser, dir, 'metacfg_bootstrap', verbose=True)
    print "* Aperio bootstrapped parser saved in '" + dir + "'"
    os.chdir(current)
    print "* Changed directory to '" + str(os.getcwd()) + "'"

def main():
    print "* Executing post-install script"
    try:
        generate_parser()
    except ImportError, e:
        print "* (Post-install error: Import error) "+str(e)
    print "* Post-install script finished"

if __name__ == '__main__':
    #~ main()
    pass

